part of xsch;

extension BuilderSchWidget on XSchedaState {
  calcCell_Negative(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (controller.text == "") {
    } else {
      if (xCol.dataType == double) {
        x = double.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      } else if (xCol.dataType == int) {
        x = int.parse(controller.text);
        if (x > 0) {
          var res = (x - numForCalc);
          if (res < 0) {
          } else {
            controller.text = res.toString();
          }
        }
      }
    }

    return x;
  }

  calcCell_Positive(XCol xCol, TextEditingController controller, numForCalc) {
    var x;
    if (xCol.dataType == double) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = double.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    } else if (xCol.dataType == int) {
      if (controller.text == "") {
        controller.text = (numForCalc).toString();
      } else {
        x = int.parse(controller.text);
        controller.text = (x + numForCalc).toString();
      }
    }
    return x;
  }

  Future<dynamic> xEntryDialog(String title, dynamic value, XCol xCol) async {
    FocusScope.of(context).unfocus();
    setState(() {
      enteredInEditOnCell = true;
    });
    TextEditingController textController = TextEditingController(text: value.toString());

    var res = await showDialog<dynamic>(
        context: context,
        barrierDismissible: false,
        builder: (context) {
          return StatefulBuilder(
            builder: (context, setState) {
              return Container(
                  alignment: Alignment.center,
                  child: SingleChildScrollView(
                      child: XAlertDialog(
                    content_insetPadding: EdgeInsets.all(5),
                    height: null,
                    title_Text: title,
                    title_Style: XStyles.xStyTextForLabel(Colors.blue),
                    btnYES_label: "OK",
                    btnNO_label: "Annulla",
                    btnNO_OnPressed: () {
                      Navigator.pop(context, null);
                    },
                    btnYES_OnPressed: () {
                      if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
                        value = textController.text;
                      } else if (xCol.dataType == DateTime) {
                        var t = textController.text.split("-");
                        value = DateTime.parse(t[2] + "-" + t[1] + "-" + t[0]);
                      } else if (xCol.dataType == double) {
                        value = double.parse(textController.text);
                      } else if (xCol.dataType == int) {
                        value = int.parse(textController.text);
                      }
                      setState(() {
                        editedPage = true;
                      });
                      xOnXCell_Edit_SubmitValue(xCol, value, setState);

                      Navigator.pop(context, value);
                    },
                    child: Row(mainAxisAlignment: MainAxisAlignment.end, crossAxisAlignment: CrossAxisAlignment.start, children: [
                      (xCol.dataType == String && xCol.colKey.startsWith("li").not())
                          ? Expanded(
                              child: Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisSize: MainAxisSize.min, children: [
                              Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                                XBtnbase(
                                  width: 40,
                                  height: 40,
                                  label: "C",
                                  label_Color: Colors.red,
                                  backGroundColor: Colors.grey[800],
                                  onPressed: () {
                                    textController.text = "";
                                  },
                                ),
                              ]),
                            ]))
                          : Container(),
                      Expanded(
                          flex: 4,
                          child: Column(mainAxisSize: MainAxisSize.min, children: [
                            SizedBox(height: 5),
                            Row(children: [Expanded(child: xDialog_CellBuilder(xCol, context, setState, textController))]),
                            SizedBox(height: 20),
                            Row(mainAxisAlignment: MainAxisAlignment.center, children: [
                              xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                  ? Container()
                                  : XBtnbase(
                                      width: 40,
                                      height: 40,
                                      label: "C",
                                      label_Color: Colors.red,
                                      backGroundColor: Colors.grey[800],
                                      onPressed: () {
                                        textController.text = "";
                                      },
                                    ),
                              SizedBox(width: 10),
                              xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                  ? Container(height: 0, width: 0)
                                  : XBtnbase(
                                      width: 40,
                                      height: 40,
                                      icon: Icons.remove,
                                      icon_Color: Colors.red,
                                      backGroundColor: Colors.grey[800],
                                      onPressed: () {
                                        calcCell_Negative(xCol, textController, 1);
                                      },
                                    ),
                              SizedBox(width: 10),
                              xCol.dataType == String && xCol.colKey.startsWith("li").not()
                                  ? Container()
                                  : XBtnbase(
                                      width: 40,
                                      height: 40,
                                      icon: Icons.add,
                                      icon_Color: Colors.green,
                                      backGroundColor: Colors.grey[800],
                                      onPressed: () {
                                        calcCell_Positive(xCol, textController, 1);
                                      },
                                    )
                            ]),
                          ])),
                      SizedBox(width: 10),
                      Expanded(
                          child: xCol.dataType == String && xCol.colKey.startsWith("li").not()
                              ? Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisSize: MainAxisSize.min, children: [
                                  XBtnbase(
                                    width: 100,
                                    height: 40,
                                    label: "Copia \nTesto",
                                    label_TextAlign: TextAlign.center,
                                    label_Color: Colors.white,
                                    padding: EdgeInsets.all(0),
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      Clipboard.setData(ClipboardData(text: textController.text));
                                      ScaffoldMessenger.of(context).showSnackBar(
                                        SnackBar(content: Text('Testo copiato negli appunti')),
                                      );
                                    },
                                  ),
                                  SizedBox(height: 10),
                                  (xCol.dataType == String && xCol.colKey.startsWith("li").not() && (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")))
                                      ? XBtnbase(
                                          width: 100,
                                          height: 40,
                                          icon: Icons.add,
                                          icon_Color: Colors.green,
                                          backGroundColor: Colors.grey[800],
                                          onPressed: () {
                                            textController.text += "+";
                                            textController.selection = TextSelection(baseOffset: textController.text.length, extentOffset: textController.text.length);
                                          },
                                        )
                                      : Container()
                                ])
                              : Column(crossAxisAlignment: CrossAxisAlignment.start, mainAxisSize: MainAxisSize.min, children: [
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "-10",
                                    label_Color: Colors.red,
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      calcCell_Negative(xCol, textController, 10);
                                    },
                                  ),
                                  SizedBox(height: 8),
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "-5",
                                    label_Color: Colors.red,
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      calcCell_Negative(xCol, textController, 5);
                                    },
                                  ),
                                  SizedBox(height: 8),
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "-1",
                                    label_Color: Colors.red,
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      calcCell_Negative(xCol, textController, 1);
                                    },
                                  ),
                                  SizedBox(height: 8),
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "+1",
                                    label_Color: Colors.green,
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      calcCell_Positive(xCol, textController, 1);
                                    },
                                  ),
                                  SizedBox(height: 8),
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "+5",
                                    label_Color: Colors.green,
                                    backGroundColor: Colors.grey[800],
                                    onPressed: () {
                                      calcCell_Positive(xCol, textController, 5);
                                    },
                                  ),
                                  SizedBox(height: 8),
                                  XBtnbase(
                                    width: 40,
                                    height: 30,
                                    label: "+10",
                                    backGroundColor: Colors.grey[800],
                                    label_Color: Colors.green,
                                    onPressed: () {
                                      calcCell_Positive(xCol, textController, 10);
                                    },
                                  ),
                                ])),
                    ]),
                  )));
            },
          );
        });
    setState(() {
      enteredInEditOnCell = false;
    });
    return res;
  }

  Container xDialog_CellBuilder(XCol xCol, BuildContext context, void Function(void Function()) setState, TextEditingController controller) {
    Widget _widgetForCell = Container();
    //WIDGET NEL CASO FOSSE UNA STRING
    if (xCol.dataType == String && xCol.colKey.startsWith("li").not()) {
      _widgetForCell = xSch_TextFormField_Builder(
        height: null,
        context: context,
        xCol: xCol,
        controller: controller,
        label_Visible: false,
        multiLines: xCol.width >= 200 ? true : false,
        editable: xCol.readOnly,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        // value: item ?? "",
        onChanged: (value) {
          xOnXCell_Edit_OnChanged(xCol, value);
        },
      );
    }
    //WIDGET NEL CASO FOSSE UN DATETIME
    else if (xCol.dataType == DateTime) {
      print("cazzo " + controller.text);
      var dt = DateTime.parse(controller.text.replaceRange(10, controller.text.length, ""));
      _widgetForCell = xSch_DateFormField_Builder(
          xCol: xCol,
          onBefore_Edit: () {
            // return DatePicker.showDatePicker(
            //   context,
            //   showTitleActions: true,
            //   minTime: DateTime(2022, 3, 5),
            //   maxTime: DateTime(2040, 6, 7),
            //   // onChanged: (date) {
            //   //   setState(() {
            //   //     (value) => onDateSelected!(value);
            //   //     value = date;
            //   //   });
            //   // },
            //   onConfirm: (date) {
            //     setState(() {
            //       controller.text = XUtils.dateToString(date);
            //     });
            //   },
            //   // theme: DatePickerTheme(),
            //   currentTime: dt,
            //   locale: LocaleType.it,
            // );
          },
          controller: controller,
          // value: dt == DateTime(1900, 01, 01) ? null : dt,
          onDateSelected: (value) {
            // setState(() {
            //   btnUpdateChangesShow = true;
            xOnXCell_Edit_SubmitValue(xCol, value, setState);
            //});
          });
    }
    //WIDGET NEL CASO FOSSE UN DOUBLE
    else if (xCol.dataType == double) {
      _widgetForCell = xSch_TextFormField_Builder(
          context: context,
          selectText: true,
          editable: xCol.readOnly,
          xCol: xCol,
          label_Visible: false,
          maxLines: 1,
          borderColor: widget.cell_borderColor,
          borderColor_Disabled: widget.cell_borderColor_Disabled,
          labelColor_Disabled: widget.cell_labelColor_Disabled,
          onBefore_Edit: () {
            // xOnBefore_Edit(xCol, item);
          },
          keyboardType: TextInputType.number,
          controller: controller,
          // value: controller.text == "0.0" ? "" : double.parse(controller.text).toString(),
          inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
          onSubmitted: (value) {
            xOnXCell_Edit_SubmitValue(xCol, double.parse(value), setState);
          },
          onChanged: (value) {
            if (value != "") {
              xOnXCell_Edit_OnChanged(xCol, double.parse(value));
            } else {
              xOnXCell_Edit_OnChanged(xCol, 0.0);
            }
          });
    }
    //WIDGET NEL CASO FOSSE UN INTERO
    else if (xCol.dataType == int) {
      _widgetForCell = xSch_TextFormField_Builder(
        context: context,
        editable: xCol.readOnly,
        selectText: true,
        maxLines: 1,
        label_Visible: false,
        xCol: xCol,
        borderColor: widget.cell_borderColor,
        borderColor_Disabled: widget.cell_borderColor_Disabled,
        labelColor_Disabled: widget.cell_labelColor_Disabled,
        keyboardType: TextInputType.number,
        onBefore_Edit: () {
          // xOnBefore_Edit(xCol, item);
        },
        onSubmitted: (value) {
          xOnXCell_Edit_SubmitValue(xCol, value, setState);
        },
        controller: controller,
        // value: controller.text == "0.0" ? "" : controller.text,
        inputFormatters: [FilteringTextInputFormatter.deny(RegExp("[- /,\\\\]"))],
        onChanged: (value) {
          if (value != "") {
            xOnXCell_Edit_OnChanged(xCol, int.parse(value));
          } else {
            xOnXCell_Edit_OnChanged(xCol, 0);
          }
        },
      );
    } else {
      return Container(width: 0, height: 0);
    }

    return Container(
      child: StatefulBuilder(builder: (context, setState) {
        return _widgetForCell;
      }),
    );
    //}
  }

  Widget xSch_TextFormField_Builder<T>({
    required BuildContext context,
    required XCol xCol,
    Function(String)? onChanged,
    Function(String)? onSubmitted,
    String? hintText,
    List<TextInputFormatter>? inputFormatters,
    TextInputType? keyboardType,
    bool editable = true,
    bool label_Visible = true,
    String? value,
    bool? selectText,
    bool? multiLines,
    double? height,
    int? maxLines,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Color? backgorundColor,
    Color? backgorundColor_Disabled,
    TextEditingController? controller,
    Function()? onBefore_Edit,
  }) {
    return XTextFormField(
      controller: value != null ? null : controller,
      border: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
      label: label_Visible ? (xCol.colCaption + (xCol.format == "C" ? " €" : "")) : "",
      onChanged: onChanged,
      onFieldSubmitted: (value) {
        onSubmitted == null ? null : onSubmitted(value!);
      },
      onTap: () {
        if (controller != null) {
          if (xCol.dataType == String) {
          } else {
            controller.selection = TextSelection(baseOffset: 0, extentOffset: controller.text.length);
          }
        }
        onBefore_Edit!();
      },
      initialValue: controller != null ? null : value,
      // borderVisible: editable.not(),
      // maxLines: maxLines,
      isCollapsed: false,
      enabled: editable.not(),
      height: null,
      fillColor: editable ? Colors.transparent : XSchedaState.color_CellBackGorundDisabled,
      filled: XSchedaState.color_CellBackGorundDisabled != null ? true : false,
      multiLines: (xCol.colCaption.toLowerCase().contains("email") || (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto")) || xCol.colCaption.toLowerCase().contains("inidrizzo") || xCol.colCaption.toLowerCase().contains("ind"))
          ? false
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? false
              : multiLines ?? false,
      contentPadding: EdgeInsets.only(top: 7, left: 5, bottom: 7),
      textStyle: XStyles.xStyleText(colorText: XSchedaState.color_Text),
      labelStyle: XStyles.xStyTextForLabel(editable.not() ? (XSchedaState.color_LabelText) : (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!)), //XSchedaState.colorOfHintText
      keyboardType: (xCol.colCaption.toLowerCase().contains("email"))
          ? TextInputType.emailAddress
          : ((xCol.colCaption.toLowerCase().contains("cell")) || (xCol.colCaption.toLowerCase().contains("tel")))
              ? TextInputType.phone
              : (xCol.colKey.contains("sconti") || xCol.colKey.contains("sconto"))
                  ? TextInputType.number
                  : TextInputType.text,
      textCapitalization: (xCol.dataType == String && xCol.colKey.startsWith("li").not())
          ? TextCapitalization.sentences //
          : TextCapitalization.none,
      hintText: editable ? "..." : (hintText ?? "inserisci.."),
      inputFormatters: inputFormatters ?? [],
    );
  }

  Widget xSch_Text_Builder<T>({required BuildContext context, required XCol xCol, required String value, List<TextInputFormatter>? inputFormatters, double? height}) {
    return XTextWithLabel(
      label: xCol.colCaption,
      text: xCol.format == "C" ? XUtils.xToCurrency(context, double.parse(value)) : value,
      text_Style: XStyles.xStyTextForDescr(Colors.white),
      label_Style: XStyles.xStyTextForLabel(XSchedaState.color_HintText),
    );
  }

  Widget xSch_DateFormField_Builder({
    required XCol xCol,
    required Function(DateTime)? onDateSelected,
    bool editable = true,
    DateTime? value,
    Color? borderColor,
    Color? borderColor_Disabled,
    Color? labelColor_Disabled,
    Function()? onBefore_Edit,
    TextEditingController? controller,
  }) {
    return GestureDetector(
        // onTap: () {
        //   onBefore_Edit!();
        // },
        child: DateTimeFormField(
            decoration: InputDecoration(
              contentPadding: EdgeInsets.only(right: 2, top: 2, bottom: 2),
              hintStyle: XStyles.xStyleText(fontSize: 15, colorText: XSchedaState.color_HintText),
              errorStyle: TextStyle(color: Colors.redAccent),
              border: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              disabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              enabledBorder: OutlineInputBorder(borderSide: BorderSide(color: editable.not() ? (borderColor ?? Colors.grey[600]!) : (borderColor_Disabled ?? Colors.grey[700]!), width: 1)),
              labelText: xCol.colCaption,
              constraints: BoxConstraints(maxHeight: 35),
              labelStyle: value != null ? XStyles.xStyTextForLabel(editable ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)) : XStyles.xStyTextForDescr(editable.not() ? (labelColor_Disabled ?? borderColor_Disabled ?? Colors.grey[700]!) : (labelColor_Disabled ?? borderColor ?? Colors.grey[600]!)),
            ),
            enabled: editable.not(),
            initialValue: value,
            dateFormat: DateFormat("dd/MM/yy"),
            dateTextStyle: XStyles.xStyleText(fontSize: 15, colorText: Colors.white),
            initialEntryMode: DatePickerEntryMode.calendar,
            initialDatePickerMode: DatePickerMode.day,
            mode: DateTimeFieldPickerMode.date,
            autovalidateMode: AutovalidateMode.onUserInteraction,
            validator: (e) => (e?.day ?? 0) == 1 ? 'Perfavore sistema la data' : null,
            onDateSelected: (value) => onDateSelected!(value)));
  }
}
